#include <bits/stdc++.h>
using namespace std;
#define int long long
#define vt vector
vt<vt<int>> p, w;
map<vt<int>, int> wer;
vt<bool> vis;
vt<int> q;
int ans;
void solve(){
	ans=0; q.clear(); vis.clear(); p.clear(); w.clear();
	int n; cin>>n;
	q.resize(n+1); vis.resize(2*n+1); w.resize(2*n+1); p.resize(2*n+1);
	//clog<<q.size()<<"!!\n";
	for(int i=0; i<n; i++){
		int u, v, d;
		cin>>u>>v>>d;
		q[i]=d;
		wer[{u, v}]=i+1;
		p[i].push_back(u); p[i].push_back(v); w[u].push_back(i); w[v].push_back(i);
	}
	for(int i=0; i<n; i++){
		for(int j=i+1; j<n; j++){
			for(int k=j+1; k<n; k++){
				set<int> s;
				s.insert(p[i][0]);
				s.insert(p[i][1]);
				s.insert(p[j][0]);
				s.insert(p[j][1]);
				s.insert(p[k][0]);
				s.insert(p[k][1]);
				if(s.size()==3){
					ans=max(q[i]+q[j]+q[k], ans);
				}
			}
		}
	}
	for(int i=1; i<=2*n; i++){
		int s=0;
		for(auto j:w[i]){
			s+=q[j];
		}
		ans=max(s, ans);
	}
	cout<<ans<<"\n";
}
signed main(){
	
	ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
	int t;
	cin>>t;
	while(t--) solve();
}